stages:
  - tests
  - build
  - staging
  - production
  - deploy

image: docker:git

services:
  - docker:dind

variables:
  GIT_SUBMODULE_STRATEGY: recursive

run-unit-tests:
  stage: tests
  image: node:alpine
  before_script:
    - npm ci
  script:
    - npm run test

build-staging-image:
  only:
    - master

  stage: build

  before_script:
    - docker pull wiseteam/engrave-$CI_PROJECT_NAME:staging || true # true to not fail if repository is empty

  script:
    - docker build --pull --cache-from wiseteam/engrave-$CI_PROJECT_NAME:staging . -t wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA -t wiseteam/engrave-$CI_PROJECT_NAME:staging
    - echo $HUB_PASSWORD | docker login -u "$HUB_USERNAME" --password-stdin
    - docker push wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
    - docker push wiseteam/engrave-$CI_PROJECT_NAME:staging

  after_script:
    - docker images

.update-staging:
  stage: staging

  environment:
    name: staging
    url: https://engrave.dev

  before_script:
    - mkdir -p ~/.docker
    - echo "$TLSCACERT" > ~/.docker/ca.pem
    - echo "$TLSCERT" > ~/.docker/cert.pem
    - echo "$TLSKEY" > ~/.docker/key.pem
    - docker -H $SWARM_HOST_STAGING --tlsverify pull wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
  script:
    - docker -H $SWARM_HOST_STAGING --tlsverify service update --image wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA --update-failure-action rollback --update-order start-first engrave_staging_$CI_PROJECT_NAME
  only:
    - master


deploy-engrave:
  stage: deploy

  environment:
    name: engrave
    url: https://engrave.website

  before_script:
    - mkdir -p ~/.docker
    - echo "$ENGRAVE_TLSCACERT" > ~/.docker/ca.pem
    - echo "$ENGRAVE_TLSCERT" > ~/.docker/cert.pem
    - echo "$ENGRAVE_TLSKEY" > ~/.docker/key.pem
    - docker -H $ENGRAVE_SWARM_HOST --tlsverify pull wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
  script:
    - docker -H $ENGRAVE_SWARM_HOST --tlsverify service update --image wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA --update-failure-action rollback --update-order start-first engrave_$CI_PROJECT_NAME
  only:
    - master
  when: manual

deploy-dblog:
  stage: deploy

  environment:
    name: dblog
    url: https://dblog.pl

  before_script:
    - mkdir -p ~/.docker
    - echo "$DBLOG_TLSCACERT" > ~/.docker/ca.pem
    - echo "$DBLOG_TLSCERT" > ~/.docker/cert.pem
    - echo "$DBLOG_TLSKEY" > ~/.docker/key.pem
    - docker -H $DBLOG_SWARM_HOST --tlsverify pull wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA
  script:
    - docker -H $DBLOG_SWARM_HOST --tlsverify service update --image wiseteam/engrave-$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA --update-failure-action rollback --update-order start-first dblog_$CI_PROJECT_NAME
  only:
    - master
  when: manual
